【Revit】 Revit二次开发针对墙创建剖切面

任何一个视图View,有三个方向,分别是ViewDirection(朝着观察者的方向),RightDirection(朝着屏幕的右边),UpDirection(朝着屏幕的上边)。

ViewSection.CreatSection方法,可以创建剖面,该方法中的第三个参数是一个BoundingBoxXYZ类型:sectionBox。

sectionBox.Transform.BasisZ的值指定了生成的剖面的ViewDirection;

sectionBox.Transform.BasisY的值指定了生成的剖面的UpDirection;

sectionBox.Transform.BasisX的值指定了生成的剖面的RightDirection;

直接上代码:

        /// <summary>
        /// 创建墙剖面图
        /// </summary>
        /// <param name="wall">墙</param>
        /// <param name="viewFamilyType"></param>
        /// <param name="centerloc">中间点的位置(单位英寸)</param>
        /// <param name="direction">方向(单位英寸)</param>
        /// <param name="depth">深度(单位英寸)</param>
        /// <returns></returns>
        private Element CreateWallSection(Wall wall, ViewFamilyType viewFamilyType, XYZ centerloc, XYZ direction, double depth = 5)
        {
            try
            {
                if (wall == null) return null;
                var line = ((wall.Location as LocationCurve).Curve as Autodesk.Revit.DB.Line);
                var length = line.Length / 2 + 0.5;
                var box = wall.get_BoundingBox(null);
                var min = new XYZ(-length, box.Min.Z, 0);
                var max = new XYZ(length, box.Max.Z, depth);
                var center = new XYZ(centerloc.X, centerloc.Y, (box.Min.Z + box.Max.Z) / 2);

                Transform transform = Transform.Identity;
                transform.Origin = center;
                transform.BasisX = -direction.CrossProduct(XYZ.BasisZ).Normalize();
                transform.BasisY = XYZ.BasisZ;
                transform.BasisZ = direction;
                var newbox = new BoundingBoxXYZ() { Min = min, Max = max, Transform = transform };

                ViewSection viewSection = null;
          //开事务
                TransactionUtils.InvokeTransaction(_doc, "创建墙剖面", () =>
                {
                    viewSection = ViewSection.CreateSection(_doc, viewFamilyType.Id, newbox);
                    viewSection.SetViewName("剖面_" + wall.Id.IntegerValue);
                    viewSection.CropBoxActive = true;
                    viewSection.DisplayStyle = DisplayStyle.ShadingWithEdges;
                    viewSection.DetailLevel = ViewDetailLevel.Fine;
                    viewSection.IsolateElementTemporary(wall.Id);
                });
                return viewSection;
            }
            catch
            { return null; }
        }

其中:

//筛选对应的类型,此处使用了自己写的扩展方法
ViewFamilyType viewFamilyType = _doc.WherePasses(new ElementClassFilter(typeof(ViewFamilyType))).FirstOrDefault(x => ViewFamily.Section == (x as ViewFamilyType).ViewFamily) as ViewFamilyType;
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值